commit ccd8a6f23f1285ad61698579c9a350b568af0565
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Tue Feb 28 15:22:57 2023 +0100

    Disconnect the rotation axis in the Tablebases from the axis in the objects.

diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
index d76a2183..4e5f7e8c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
@@ -33,7 +33,7 @@ import org.distorted.objectlib.shape.ShapeHexahedron;
 
 public class TwistyCuboid extends ShapeHexahedron
 {
-  public static final Static3D[] ROT_AXIS = new Static3D[]
+  static final Static3D[] ROT_AXIS = new Static3D[]
          {
            new Static3D(1,0,0),
            new Static3D(0,1,0),
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
index 94148538..a2e3f9cb 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
@@ -33,7 +33,7 @@ import org.distorted.objectlib.shape.ShapeHexahedron;
 
 public class TwistyIvy extends ShapeHexahedron
 {
-  public static final Static3D[] ROT_AXIS = new Static3D[]
+  static final Static3D[] ROT_AXIS = new Static3D[]
          {
            new Static3D( SQ3/3, SQ3/3, SQ3/3),
            new Static3D( SQ3/3, SQ3/3,-SQ3/3),
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
index 284c938f..69e44e8e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
@@ -32,7 +32,7 @@ import org.distorted.objectlib.shape.ShapeTetrahedron;
 
 public class TwistyPyraminx extends ShapeTetrahedron
 {
-  public static final Static3D[] ROT_AXIS = new Static3D[]
+  static final Static3D[] ROT_AXIS = new Static3D[]
          {
            new Static3D(     0,-SQ3/3,-SQ6/3),
            new Static3D(     0,-SQ3/3, SQ6/3),
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminxDuo.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminxDuo.java
index 5535135e..23ba1f71 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminxDuo.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminxDuo.java
@@ -31,7 +31,7 @@ import java.io.InputStream;
 
 public class TwistyPyraminxDuo extends ShapeTetrahedron
 {
-  public static final Static3D[] ROT_AXIS = new Static3D[]
+  static final Static3D[] ROT_AXIS = new Static3D[]
          {
            new Static3D(     0,-SQ3/3,-SQ6/3),
            new Static3D(     0,-SQ3/3, SQ6/3),
diff --git a/src/main/java/org/distorted/objectlib/tablebases/TablebasesCuboid232.java b/src/main/java/org/distorted/objectlib/tablebases/TablebasesCuboid232.java
index 248b6727..0ea3f145 100644
--- a/src/main/java/org/distorted/objectlib/tablebases/TablebasesCuboid232.java
+++ b/src/main/java/org/distorted/objectlib/tablebases/TablebasesCuboid232.java
@@ -12,7 +12,6 @@ package org.distorted.objectlib.tablebases;
 import android.content.res.Resources;
 
 import org.distorted.library.type.Static3D;
-import org.distorted.objectlib.objects.TwistyCuboid;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -57,7 +56,12 @@ public class TablebasesCuboid232 extends TablebasesAbstract
 
   Static3D[] getRotationAxis()
     {
-    return TwistyCuboid.ROT_AXIS;
+    return new Static3D[]
+         {
+           new Static3D(1,0,0),
+           new Static3D(0,1,0),
+           new Static3D(0,0,1)
+         };
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/tablebases/TablebasesIvyCube.java b/src/main/java/org/distorted/objectlib/tablebases/TablebasesIvyCube.java
index bad41139..31d7d15b 100644
--- a/src/main/java/org/distorted/objectlib/tablebases/TablebasesIvyCube.java
+++ b/src/main/java/org/distorted/objectlib/tablebases/TablebasesIvyCube.java
@@ -12,7 +12,7 @@ package org.distorted.objectlib.tablebases;
 import android.content.res.Resources;
 
 import org.distorted.library.type.Static3D;
-import org.distorted.objectlib.objects.TwistyIvy;
+import static org.distorted.objectlib.main.TwistyObject.SQ3;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -53,7 +53,13 @@ public class TablebasesIvyCube extends TablebasesAbstract
 
   Static3D[] getRotationAxis()
     {
-    return TwistyIvy.ROT_AXIS;
+    return new Static3D[]
+         {
+           new Static3D( SQ3/3, SQ3/3, SQ3/3),
+           new Static3D( SQ3/3, SQ3/3,-SQ3/3),
+           new Static3D( SQ3/3,-SQ3/3, SQ3/3),
+           new Static3D( SQ3/3,-SQ3/3,-SQ3/3)
+         };
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminx.java b/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminx.java
index dbe7337b..a17fa225 100644
--- a/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminx.java
@@ -10,13 +10,13 @@
 package org.distorted.objectlib.tablebases;
 
 import static org.distorted.objectlib.main.TwistyObject.SQ2;
+import static org.distorted.objectlib.main.TwistyObject.SQ3;
 import static org.distorted.objectlib.main.TwistyObject.SQ6;
 
 import android.content.res.Resources;
 
 import org.distorted.library.type.Static3D;
 import org.distorted.objectlib.R;
-import org.distorted.objectlib.objects.TwistyPyraminx;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -58,7 +58,13 @@ public class TablebasesPyraminx extends TablebasesAbstract
 
   Static3D[] getRotationAxis()
     {
-    return TwistyPyraminx.ROT_AXIS;
+    return new Static3D[]
+         {
+           new Static3D(     0,-SQ3/3,-SQ6/3),
+           new Static3D(     0,-SQ3/3, SQ6/3),
+           new Static3D( SQ6/3, SQ3/3,     0),
+           new Static3D(-SQ6/3, SQ3/3,     0),
+         };
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminxDuo.java b/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminxDuo.java
index 108a2220..29447eea 100644
--- a/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminxDuo.java
+++ b/src/main/java/org/distorted/objectlib/tablebases/TablebasesPyraminxDuo.java
@@ -10,11 +10,12 @@
 package org.distorted.objectlib.tablebases;
 
 import static org.distorted.objectlib.main.TwistyObject.SQ2;
+import static org.distorted.objectlib.main.TwistyObject.SQ3;
+import static org.distorted.objectlib.main.TwistyObject.SQ6;
 
 import android.content.res.Resources;
 
 import org.distorted.library.type.Static3D;
-import org.distorted.objectlib.objects.TwistyPyraminxDuo;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -46,7 +47,13 @@ public class TablebasesPyraminxDuo extends TablebasesAbstract
 
   Static3D[] getRotationAxis()
     {
-    return TwistyPyraminxDuo.ROT_AXIS;
+    return new Static3D[]
+         {
+           new Static3D(     0,-SQ3/3,-SQ6/3),
+           new Static3D(     0,-SQ3/3, SQ6/3),
+           new Static3D( SQ6/3, SQ3/3,     0),
+           new Static3D(-SQ6/3, SQ3/3,     0),
+         };
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////