commit 33ba467ad63dc7b6f1b0b0354c2c42f2af5326cf
Author: leszek <leszek@koltunski.pl>
Date:   Wed Mar 13 00:34:41 2024 +0100

    Color unification complete: 24 standard colors.

diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index c64f4dba..b302da4f 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -38,7 +38,7 @@ public class TwistyMirror extends ShapeHexahedron
            new Static3D(0,0,1)
          };
 
-  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_ICO_WHITE };
+  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_WHITE};
   private static final float[] MIRROR_VEC = { 0.10f, 0.25f, 0.40f };
 
   private int[][] mEdges;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirrorJing.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirrorJing.java
index 2f68d502..e04e7e3c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirrorJing.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirrorJing.java
@@ -41,7 +41,7 @@ public class TwistyMirrorJing extends ShapeTetrahedron
 
   private static final float JING_F = 0.48f;
 
-  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_ICO_WHITE };
+  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_WHITE};
   private static final float[] MIRROR_VEC = { 0.06f, 0.07f, 0.08f };
 
   private int[][] mEdges;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirrorPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirrorPyraminx.java
index 72070a88..c34bbf49 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirrorPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirrorPyraminx.java
@@ -38,7 +38,7 @@ public class TwistyMirrorPyraminx extends ShapeTetrahedron
       new Static3D(-SQ6/3, SQ3/3,     0),
     };
 
-  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_ICO_WHITE };
+  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_WHITE};
   private static final float[] MIRROR_VEC = { 0.06f, 0.15f, 0.02f };
 
   private int[][] mEdges;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirrorSkewb.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirrorSkewb.java
index 0166bf27..bd1ac4eb 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirrorSkewb.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirrorSkewb.java
@@ -39,7 +39,7 @@ public class TwistyMirrorSkewb extends ShapeHexahedron
            new Static3D( SQ3/3,-SQ3/3,-SQ3/3)
          };
 
-  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_ICO_WHITE };
+  private static final int[] FACE_COLORS = new int[] { ShapeColors.COLOR_WHITE};
   private static final float[] MIRROR_VEC = { 0.10f, 0.15f, 0.20f };
 
   private int[][] mEdges;
diff --git a/src/main/java/org/distorted/objectlib/shape/ShapeColors.java b/src/main/java/org/distorted/objectlib/shape/ShapeColors.java
index a7d2f65a..88b4b12d 100644
--- a/src/main/java/org/distorted/objectlib/shape/ShapeColors.java
+++ b/src/main/java/org/distorted/objectlib/shape/ShapeColors.java
@@ -13,38 +13,28 @@ package org.distorted.objectlib.shape;
 
 public class ShapeColors
 {
-  public static final int COLOR_BALL_1 = 0xffcc0000;
-  public static final int COLOR_BALL_2 = 0xffcb2d6a;
-  public static final int COLOR_BALL_3 = 0xff4ec9d0;
-  public static final int COLOR_BALL_4 = 0xff4678ab;
-  public static final int COLOR_BALL_5 = 0xff057350;
-  public static final int COLOR_BALL_6 = 0xff48ad62;
-  public static final int COLOR_BALL_7 = 0xffedca54;
-  public static final int COLOR_BALL_8 = 0xfffe5740;
-
-  public static final int COLOR_ICO_LPINK  = 0xffe191b4;
-  public static final int COLOR_ICO_VIOLET = 0xff7700bb; //604c94
-  public static final int COLOR_ICO_PURPLE = 0xff472258;
-  public static final int COLOR_ICO_BURGUN = 0xff591218;
-  public static final int COLOR_ICO_DPINK  = 0xffba365b;
-  public static final int COLOR_ICO_YELLOW = 0xffffff00; // ffff77
-  public static final int COLOR_ICO_LGREEN = 0xff00bb00; // 53aa00
-  public static final int COLOR_ICO_BLUE   = 0xff0000ff; // 0e28a3
-  public static final int COLOR_ICO_GREY   = 0xff727c7b; // 566069
-  public static final int COLOR_ICO_ORANGE = 0xffff6200; // d7660a
-  public static final int COLOR_ICO_DGREEN = 0xff092d2b;
-  public static final int COLOR_ICO_SELEDY = 0xff034d3e; //
-  public static final int COLOR_ICO_GREEN  = 0xff1a7516;
-  public static final int COLOR_ICO_BLUEISH= 0xff58b6be;
-  public static final int COLOR_ICO_SANDY  = 0xffd3c49b;
-  public static final int COLOR_ICO_DBLUE  = 0xff0a1662;
-  public static final int COLOR_ICO_RED    = 0xff990000; // a21a1c
-  public static final int COLOR_ICO_DYELLO = 0xffe1b410; //
-  public static final int COLOR_ICO_DWHITE = 0xffdadeea;
-  public static final int COLOR_ICO_LBLUE  = 0xff0157da;
-
-  public static final int COLOR_ICO_BLACK = 0xff050505;
-  public static final int COLOR_ICO_DGREY = 0xff222222;
-  public static final int COLOR_ICO_LGREY = 0xff555555;
-  public static final int COLOR_ICO_WHITE = 0xffffffff;
+  public static final int COLOR_LPINK  = 0xffe191b4;
+  public static final int COLOR_VIOLET = 0xff7700bb;
+  public static final int COLOR_PURPLE = 0xff472258;
+  public static final int COLOR_BURGUN = 0xff591218;
+  public static final int COLOR_DPINK  = 0xffba365b;
+  public static final int COLOR_YELLOW = 0xffffff00;
+  public static final int COLOR_LGREEN = 0xff00bb00;
+  public static final int COLOR_BLUE   = 0xff0000ff;
+  public static final int COLOR_GREY   = 0xff727c7b;
+  public static final int COLOR_ORANGE = 0xffff6200;
+  public static final int COLOR_DGREEN = 0xff092d2b;
+  public static final int COLOR_SELEDY = 0xff034d3e;
+  public static final int COLOR_GREEN  = 0xff1a7516;
+  public static final int COLOR_BLUEISH= 0xff58b6be;
+  public static final int COLOR_SANDY  = 0xffd3c49b;
+  public static final int COLOR_DBLUE  = 0xff0a1662;
+  public static final int COLOR_RED    = 0xffaa0000;
+  public static final int COLOR_DYELLO = 0xffe1b410;
+  public static final int COLOR_BROWN  = 0xff902a2a;
+  public static final int COLOR_LBLUE  = 0xff0157da;
+  public static final int COLOR_BLACK  = 0xff050505;
+  public static final int COLOR_DGREY  = 0xff222222;
+  public static final int COLOR_LGREY  = 0xff555555;
+  public static final int COLOR_WHITE  = 0xffffffff;
 }
diff --git a/src/main/java/org/distorted/objectlib/shape/ShapeDiamond.java b/src/main/java/org/distorted/objectlib/shape/ShapeDiamond.java
index bb9ed535..729f1cb9 100644
--- a/src/main/java/org/distorted/objectlib/shape/ShapeDiamond.java
+++ b/src/main/java/org/distorted/objectlib/shape/ShapeDiamond.java
@@ -25,14 +25,14 @@ public abstract class ShapeDiamond extends TwistyObject
 
   public static final int[] FACE_COLORS = new int[]
          {
-           COLOR_BALL_1, COLOR_BALL_1,
-           COLOR_BALL_2, COLOR_BALL_2,
-           COLOR_BALL_3, COLOR_BALL_3,
-           COLOR_BALL_4, COLOR_BALL_4,
-           COLOR_BALL_5, COLOR_BALL_5,
-           COLOR_BALL_6, COLOR_BALL_6,
-           COLOR_BALL_7, COLOR_BALL_7,
-           COLOR_BALL_8, COLOR_BALL_8,
+                 COLOR_RED, COLOR_RED,
+                 COLOR_DPINK, COLOR_DPINK,
+                 COLOR_BLUEISH, COLOR_BLUEISH,
+                 COLOR_LBLUE, COLOR_LBLUE,
+                 COLOR_SELEDY, COLOR_SELEDY,
+                 COLOR_LGREEN, COLOR_LGREEN,
+                 COLOR_DYELLO, COLOR_DYELLO,
+                 COLOR_ORANGE, COLOR_ORANGE,
          };
 
   public static final int NUM_FACES = 16;
diff --git a/src/main/java/org/distorted/objectlib/shape/ShapeDodecahedron.java b/src/main/java/org/distorted/objectlib/shape/ShapeDodecahedron.java
index ce5b942f..016a07cd 100644
--- a/src/main/java/org/distorted/objectlib/shape/ShapeDodecahedron.java
+++ b/src/main/java/org/distorted/objectlib/shape/ShapeDodecahedron.java
@@ -25,9 +25,9 @@ public abstract class ShapeDodecahedron extends TwistyObject
 
   public static final int[] FACE_COLORS = new int[]
          {
-           COLOR_ICO_DYELLO, COLOR_ICO_ORANGE, COLOR_ICO_RED  , COLOR_ICO_SANDY,
-           COLOR_ICO_DBLUE , COLOR_ICO_WHITE , COLOR_ICO_GREY , COLOR_ICO_LBLUE,
-           COLOR_ICO_LGREEN, COLOR_ICO_VIOLET, COLOR_ICO_LPINK, COLOR_ICO_DGREEN
+                 COLOR_DYELLO, COLOR_ORANGE, COLOR_RED, COLOR_SANDY,
+                 COLOR_DBLUE, COLOR_WHITE, COLOR_GREY, COLOR_LBLUE,
+                 COLOR_LGREEN, COLOR_VIOLET, COLOR_LPINK, COLOR_DGREEN
          };
 
   public static final int NUM_FACES = 12;
diff --git a/src/main/java/org/distorted/objectlib/shape/ShapeHexahedron.java b/src/main/java/org/distorted/objectlib/shape/ShapeHexahedron.java
index b8162651..f7f2be33 100644
--- a/src/main/java/org/distorted/objectlib/shape/ShapeHexahedron.java
+++ b/src/main/java/org/distorted/objectlib/shape/ShapeHexahedron.java
@@ -25,9 +25,9 @@ public abstract class ShapeHexahedron extends TwistyObject
 
   public static final int[] FACE_COLORS = new int[]
          {
-           COLOR_ICO_YELLOW, COLOR_ICO_WHITE,
-           COLOR_ICO_BLUE  , COLOR_ICO_LGREEN,
-           COLOR_ICO_RED   , COLOR_ICO_ORANGE
+                 COLOR_YELLOW, COLOR_WHITE,
+                 COLOR_BLUE, COLOR_LGREEN,
+                 COLOR_RED, COLOR_ORANGE
          };
 
   public static final int NUM_FACES = 6;
diff --git a/src/main/java/org/distorted/objectlib/shape/ShapeIcosahedron.java b/src/main/java/org/distorted/objectlib/shape/ShapeIcosahedron.java
index 9205807e..e73f6c2e 100644
--- a/src/main/java/org/distorted/objectlib/shape/ShapeIcosahedron.java
+++ b/src/main/java/org/distorted/objectlib/shape/ShapeIcosahedron.java
@@ -25,10 +25,10 @@ public abstract class ShapeIcosahedron extends TwistyObject
 
   public static final int[] FACE_COLORS = new int[]
          {
-           COLOR_ICO_LPINK , COLOR_ICO_VIOLET, COLOR_ICO_PURPLE, COLOR_ICO_BURGUN , COLOR_ICO_DPINK ,
-           COLOR_ICO_YELLOW, COLOR_ICO_LGREEN, COLOR_ICO_BLUE  , COLOR_ICO_GREY   , COLOR_ICO_ORANGE,
-           COLOR_ICO_DGREEN, COLOR_ICO_SELEDY, COLOR_ICO_GREEN , COLOR_ICO_BLUEISH, COLOR_ICO_SANDY ,
-           COLOR_ICO_DBLUE , COLOR_ICO_RED   , COLOR_ICO_DYELLO, COLOR_ICO_WHITE  , COLOR_ICO_LBLUE,
+                 COLOR_LPINK, COLOR_VIOLET, COLOR_PURPLE, COLOR_BURGUN, COLOR_DPINK,
+                 COLOR_YELLOW, COLOR_LGREEN, COLOR_BLUE, COLOR_GREY, COLOR_ORANGE,
+                 COLOR_DGREEN, COLOR_SELEDY, COLOR_GREEN, COLOR_BLUEISH, COLOR_SANDY,
+                 COLOR_DBLUE, COLOR_RED, COLOR_DYELLO, COLOR_WHITE, COLOR_LBLUE,
          };
 
   public static final int NUM_FACES = 20;
diff --git a/src/main/java/org/distorted/objectlib/shape/ShapeOctahedron.java b/src/main/java/org/distorted/objectlib/shape/ShapeOctahedron.java
index 8be05cd6..29a95fb8 100644
--- a/src/main/java/org/distorted/objectlib/shape/ShapeOctahedron.java
+++ b/src/main/java/org/distorted/objectlib/shape/ShapeOctahedron.java
@@ -25,10 +25,10 @@ public abstract class ShapeOctahedron extends TwistyObject
 
   public static final int[] FACE_COLORS = new int[]
          {
-           COLOR_ICO_VIOLET, COLOR_ICO_GREY  ,
-           COLOR_ICO_BLUE  , COLOR_ICO_RED   ,
-           COLOR_ICO_ORANGE, COLOR_ICO_LGREEN,
-           COLOR_ICO_WHITE , COLOR_ICO_YELLOW
+                 COLOR_VIOLET, COLOR_GREY,
+                 COLOR_BLUE, COLOR_RED,
+                 COLOR_ORANGE, COLOR_LGREEN,
+                 COLOR_WHITE, COLOR_YELLOW
          };
 
   public static final int NUM_FACES = 8;
diff --git a/src/main/java/org/distorted/objectlib/shape/ShapeTetrahedron.java b/src/main/java/org/distorted/objectlib/shape/ShapeTetrahedron.java
index 6f56451b..77952c2f 100644
--- a/src/main/java/org/distorted/objectlib/shape/ShapeTetrahedron.java
+++ b/src/main/java/org/distorted/objectlib/shape/ShapeTetrahedron.java
@@ -25,8 +25,8 @@ public abstract class ShapeTetrahedron extends TwistyObject
 
   public static final int[] FACE_COLORS = new int[]
          {
-           COLOR_ICO_LGREEN, COLOR_ICO_YELLOW,
-           COLOR_ICO_BLUE  , COLOR_ICO_RED
+                 COLOR_LGREEN, COLOR_YELLOW,
+                 COLOR_BLUE, COLOR_RED
          };
 
   public static final int NUM_FACES = 4;